;Codigo para fazer escada flutuante.
;Codigo realizado pelo aluna Caíque Xavier, da turma C do 3 ano.
;Modelação e visualização tridimensional em arquitetura lecionada pelo professor Luis Romao
;Mestrado Integrado em Arquitetura - Faculdade de Arquitetura - UL

(defun c:escada-suspensa ()
  (setq altura-degrau (getreal "\nInforme a altura entre cada degrau em metros: "))
  (setq num-degraus (getint "\nInforme a quantidade de degraus da escada suspensa: "))
  (setq largura-degrau (getreal "\nInforme a largura dos degraus em metros: "))
  (setq comprimento-degrau (getreal "\nInforme o comprimento dos degraus em metros: "))
  (setq num-tirantes (getint "\nInforme a quantidade de tirantes por degrau: "))
  (setq raio-tirante (getreal "\nInforme o raio dos tirantes cilíndricos em metros: "))
  (setq altura-tirante (getreal "\nInforme a altura dos tirantes cilíndricos em metros: "))

  (setq altura-total (* altura-degrau num-degraus))

  (setq x 0.0)
  (setq y 0.0)
  (setq z 0.0)

  (setq tirantes (cons (list x y z) tirantes))

  (repeat num-degraus
    (setq x (+ x comprimento-degrau))
    (setq z (+ z altura-degrau))
    (setq tirantes (cons (list x y z) tirantes))
  )

  (setq tirantes (cons (list x y z) tirantes))

  (setq degraus (list))

  (setq x-inicial 0.0)
  (setq y-inicial 0.0)
  (setq z-inicial 0.0)

  (setq x-final (* num-degraus largura-degrau))
  (setq y-final largura-degrau)
  (setq z-final altura-total)

  (setq x-inicial-string (rtos x-inicial))
  (setq y-inicial-string (rtos y-inicial))
  (setq z-inicial-string (rtos z-inicial))
  (setq x-final-string (rtos x-final))
  (setq y-final-string (rtos y-final))
  (setq z-final-string (rtos z-final))

  (setq degrau-inicial (list x-inicial y-inicial z-inicial))
  (setq degrau-final (list x-final y-final z-final))

  (repeat num-degraus
    (setq degrau-inicial (list (+ (car degrau-inicial) comprimento-degrau) (cadr degrau-inicial) (+ (caddr degrau-inicial) altura-degrau)))
    (setq degrau-final (list (+ (car degrau-final) comprimento-degrau) (cadr degrau-final) (+ (caddr degrau-final) altura-degrau)))
    (setq degraus (cons (list degrau-inicial degrau-final) degraus))
  )

  (command "._3dface")
  (foreach degrau degraus
    (command "_non" (car degrau))
    (command "_non" (list (car (cdr degrau)) (cadr (cdr degrau)) (caddr (cdr degrau))))
    (command "_non" (list (car (car degrau)) (cadr (car degrau)) (caddr (car degrau))))
    (command "_3dface" "_cl")
  )

  (command "._3dface")
  (foreach ponto tirantes
    (command "_non" ponto)
  )
  (command "_non" (list 0.0 0.0 0.0))
  (command "._3dface" "_cl")

  (setq tirantes-cilindricos (list))
  (setq tirante-z 0.0)
  (setq tirante-y (/ largura-degrau 2.0))
  (setq espaco-tirante (/ largura-degrau (1+ num-tirantes)))
  (repeat num-degraus
    (setq tirante-x 0.0)
    (repeat num-tirantes
      (setq tirantes-cilindricos (cons (list tirante-x tirante-y tirante-z) tirantes-cilindricos))
      (setq tirante-x (+ tirante-x espaco-tirante)))
    (setq tirante-z (+ tirante-z altura-degrau)))
  (foreach tirante tirantes-cilindricos
    (setq tirante-inicial (list (- (car tirante) (/ raio-tirante 2.0)) (cadr tirante) (caddr tirante)))
    (setq tirante-final (list (+ (car tirante) (/ raio-tirante 2.0)) (cadr tirante) (+ (caddr tirante) altura-tirante)))
    (command "._cylinder" tirante-inicial tirante-final raio-tirante)
  )

  (princ)
)